import es, os.path
import playerlib, random, gamethread, cfglib, popuplib, pickle

config = cfglib.AddonCFG(es.ServerVar('eventscripts_gamedir') + '/cfg/hidden.cfg')

config.text('***************************************')
config.text('* ES Hidden V3 ESP Configuration File *')
config.text('***************************************')
config.text('\n')
config.text('* General *')
hidden_ver = config.cvar('hidden_ver', '3.3 ESP', 'ES Hidden V3 ESP Version')
dark_mode = config.cvar('dark_mode', 2, '0 = Normal, 1 = Darker, 2 = Very Dark')
config.text('\n')
config.text('* Hidden Specific *')
hidden_health = config.cvar('hidden_health', 250, 'Set the amount of HP the Hidden has')
additional_hidden_health = config.cvar('additional_hidden_health', 3, 'hidden_health / additional_hidden_health = HP that the hidden gains if he kills somebody')
hidden_speed = config.cvar('hidden_speed', 1.6, 'Set the amount of speed the Hidden has (1.0 Normal, 1.3 = Hidden-Standard, everything above = very fast')
hidden_feed_health = config.cvar('hidden_feed_health', 7, 'How many HP can the Hidden feed?')
hidden_feed_mode = config.cvar('hidden_feed_mode', 'move', 'Hidden feeds %s HP when he "move"s or "duck"s and got hit' % hidden_feed_health)
hidden_feed_time = config.cvar('hidden_feed_time', 3, 'Every X seconds the Hidden gains %s HP' % hidden_feed_health)
hidden_feed_stop = config.cvar('hidden_feed_stop', 250, 'Set the amount of HP the feeding should stop')
config.text('\n')
config.text('* IRIS Specific *')
iris_class_time = config.cvar('iris_class_time', 10, 'Set the amount of seconds an IRIS Force can change its class')
iris_adrenaline_time = config.cvar('iris_adrenaline_time', 5, 'Set the amount of seconds until an IRIS Force\'s Adrenaline Shot stops')

config.write()
reset_hidden = 0
reset_iris = 0
rank_iris = 0
rank_hidden = 0
rank_menu = 0
hidden_dead = 0
choose = 0
addition = 0
assault = 0
support = 0
sec = 0
bot_wep_prim = ('tmp;mac10;mp5navy;scout')
bot_wep_sec = ('p228;glock;usp')
sounds = ('hidden/617-radiotaunts08.mp3', 'hidden/617-radiotaunts01.mp3', 'hidden/617-radiotaunts06.mp3')
death_hidden = ('hidden/617-death01.mp3', 'hidden/617-death05.mp3')
death_iris = ('hidden/IRIS-death14.wav', 'hidden/IRIS-death04.wav')
round_count = 0
rank = {}
chosen = {}

def load():
    global rank_iris, rank_hidden, rank_menu, addition, choose, support, assault, sec, rank, chosen, reset_iris, reset_hidden
    config.execute()
    downloads()
    es.set('mp_limitteams', '0')
    es.set('mp_friendlyfire', '0')
    es.set('mp_freezetime', '5')
    es.set('sv_turbophysics', '1')
    es.set('phys_pushscale', '2')
    es.set('sv_pushaway_force', '22000')
    es.set('mp_autoteambalance', '0')
    es.makepublic('hidden_ver')
    es.server.cmd('es_xflags remove cheat endround')
    reset_hidden = popuplib.easymenu('hidden_reset', '_popup_choice', hidden_reset_men)
    reset_hidden.settitle('Reset Hidden Rank')
    reset_hidden.addoption('rank', 'Reset Rank? (0 Kills, 0 Deaths)')
    reset_hidden.addoption('spawns', 'Reset Spawns? (0)')
    reset_iris = popuplib.easymenu('iris_reset', '_popup_choice', iris_reset_men)
    reset_iris.settitle('Reset IRIS Rank')
    reset_iris.addoption('rank', 'Reset Rank? (0 Kills, 0 Deaths)')
    rank_iris = popuplib.easymenu('iris_rank', None, None)
    rank_iris.settitle('IRIS Force Rank')
    rank_iris.addoption('kills', 'Kills: 0')
    rank_iris.addoption('deaths', 'Deaths: 0')
    rank_hidden = popuplib.easymenu('hidden_rank', None, None)
    rank_hidden.settitle('Hidden Rank')
    rank_hidden.addoption('kills', 'Kills: 0')
    rank_hidden.addoption('deaths', 'Deaths: 0')
    rank_hidden.addoption('spawns', 'Spawned as Hidden: 0')
    rank_menu = popuplib.easymenu('rank_menu', '_popup_choice', rank_men)
    rank_menu.settitle('Hidden or IRIS Rank?')
    rank_menu.addoption('hidden', 'Hidden Rank')
    rank_menu.addoption('iris', 'IRIS Force Rank')
    choose = popuplib.easymenu('choose_menu', '_popup_choice', choose_menu)
    choose.settitle('Assault or Support?')
    choose.setdescription('Assault: Powerful Weapons, less HP\nSupport: Less powerful Weapons, more HP')
    choose.addoption('assault', '[ ] Assault')
    choose.addoption('support', '{ ] Support')
    assault = popuplib.easymenu('assault_menu', '_popup_choice', assault_men)
    assault.settitle('Assault Menu')
    assault.setdescription('M4A1 Carbine will set your HP to 50...')
    assault.addoption('m4a1', '[ ] FN4700 Assault Rifle (M4A1 Carbine)')
    assault.addoption('famas', '[ ] FN2000 Assault Rifle (FAMAS)')
    assault.addoption('mp5navy', '[ ] FN Navy 3200 Sub Machine Gun  (MP5Navy)')
    assault.addoption('m3', '[ ] Remington 870 MCS Shotgun (M3)')
    assault.addoption('xm1014', '[ ] FN303 Less Lethal Launcher (XM1014)')
    support = popuplib.easymenu('support_menu', '_popup_choice', support_men)
    support.settitle('Support Menu')
    support.addoption('mp5navy', '[ ] FN Navy 3200 Sub Machine Gun  (MP5Navy)')
    support.addoption('tmp', '[ ] FN Tactial Machine Gun  (TMP)')
    support.addoption('xm1014', '[ ] FN303 Less Lethal Launcher (XM1014)')
    sec = popuplib.easymenu('secondary', '_popup_choice', sec_men)
    sec.settitle('Choose a Secondary Weapon')
    sec.addoption('fiveseven', '[ ] FN FiveSeven Pistol (Fiveseven)')
    sec.addoption('p228', '[ ] FNP-9 Pistol (P228)')
    addition = popuplib.easymenu('addition_menu', '_popup_choice', addition_men)
    addition.settitle('Choose an Additional')
    addition.addoption('nvgs', '[ ] Light Amplification Goggles (NVGs)')
    if not es.exists('saycommand', 'rank'):
        es.regsaycmd('rank', 'hidden/rank_player')
    if not es.exists('saycommand', 'reset'):
        es.regsaycmd('reset', 'hidden/reset')
    if not es.exists('saycommand', '!class'):
        es.regsaycmd('!class', 'hidden/new_class')
    rank_file = es.getAddonPath('hidden') + '/rank.db'
    chosen_file = es.getAddonPath('hidden') + '/chosen.db'
    if os.path.isfile(rank_file):
        file_rank = open(rank_file)
        rank = pickle.load(file_rank)
        file_rank.close()
    if os.path.isfile(chosen_file):
        file_chosen = open(chosen_file)
        chosen = pickle.load(file_chosen)
        file_chosen.close()
    for player in playerlib.getUseridList('#all'):
        user = playerlib.uniqueid(player, True)
        if not user in rank:
            default_rank(user)
        if not user in chosen:
            default_chosen(user)

def unload():
    es.unregsaycmd('!class')
    es.unregsaycmd('rank')
    es.server.cmd('es_xflags add cheat endround')
    rank_iris.delete()
    rank_hidden.delete()
    rank_menu.delete()
    choose.delete()
    assault.delete()
    support.delete()
    sec.delete()
    addition.delete()
    save_files()
    for userid in playerlib.getUseridList('#all'):
        es.server.cmd('es_xfire %s func_buyzone Enable' % userid)
        es.server.cmd('es_xfire %s func_bomb_target Enable' % userid)
        es.server.cmd('es_xfire %s func_hostage_rescue Enable' % userid)

def es_map_start(ev):
    downloads()

def downloads():
    es.stringtable('downloadables', 'sound/hidden/617-death01.mp3')
    es.stringtable('downloadables', 'sound/hidden/617-death05.mp3')
    es.stringtable('downloadables', 'sound/hidden/617-radiotaunts01.mp3')
    es.stringtable('downloadables', 'sound/hidden/617-radiotaunts06.mp3')
    es.stringtable('downloadables', 'sound/hidden/617-radiotaunts08.mp3')
    es.stringtable('downloadables', 'sound/hidden/IRIS-death04.wav')
    es.stringtable('downloadables', 'sound/hidden/IRIS-death14.wav')
    es.stringtable('downloadables', 'sound/hidden/IRIS-roundend06.wav')
    es.stringtable('downloadables', 'sound/hidden/IRIS-roundstart02.wav')

def rank_player():
    userid = es.getcmduserid()
    rank_menu.send(userid)

def reset():
    global reset_hidden, reset_iris
    userid = es.getcmduserid()
    user = playerlib.uniqueid(userid, True)
    args = es.getargc()
    if args > 1:
        rank_type = es.getargs(1)
        if rank_type == 'hidden':
            reset_hidden.setoption('rank', 'Reset Rank? (%s Kills, %s Deaths)' % (rank[user]['hidden_kills'], rank[user]['hidden_deaths']))
            reset_hidden.setoption('spawns', 'Reset Spawns? (%s)' % rank[user]['hidden_spawns'])
            reset_hidden.send(userid)
        elif rank_type == 'iris':
            reset_iris.setoption('rank', 'Reset Rank? (%s Kills, %s Deaths)' % (rank[user]['iris_kills'], rank[user]['iris_deaths']))
            reset_iris.send(userid)
    else:
        es.tell(userid, '#multi', '#green[#lightgreenES Hidden#green] #defaultSyntax: #greenreset #lightgreenhidden/iris')

def hidden_reset_men(userid, choice, popupid):
    global rank
    user = playerlib.uniqueid(userid, True)
    if choice == 'rank':
        rank[user]['hidden_kills'] = 0
        rank[user]['hidden_deaths'] = 0
        es.tell(userid, '#multi', '#green[#lightgreenES Hidden#green] #defaultSuccessfully deleted #greenHidden #lightgreenRank')
    elif choice == 'spawns':
        rank[user]['hidden_spawns'] = 0
        es.tell(userid, '#multi', '#green[#lightgreenES Hidden#green] #defaultSuccessfully deleted #greenHidden #lightgreenSpawns')

def iris_reset_men(userid, choice, popupid):
    global rank
    user = playerlib.uniqueid(userid, True)
    if choice == 'rank':
        rank[user]['iris_kills'] = 0
        rank[user]['iris_deaths'] = 0
        es.tell(userid, '#multi', '#green[#lightgreenES Hidden#green] #defaultSuccessfully deleted #greenIRIS #lightgreenRank')

def new_class():
    global chosen
    userid = es.getcmduserid()
    user = playerlib.uniqueid(userid, True)
    if es.getplayerteam(userid) != 2:
        if chosen[user]['class_time'] == 0:
            choose.send(userid)
            chosen[user]['class_time'] = 1
            gamethread.delayed(iris_class_time, chosen[user]['class_time'], 0)
        else:
            es.tell(userid, '#multi', '#green[#lightgreenES Hidden#green] #defaultYou can only change your class within #lightgreen%s #defaultseconds!' % iris_class_time)
    else:
        es.tell(userid, '#multi', '#green[#lightgreenES Hidden#green] Hidden #lightgreencan\'t change its class!')

def rank_men(userid, choice, popupid):
    global rank_hidden, rank_iris
    user = playerlib.uniqueid(userid, True)
    if choice == 'hidden':
        rank_hidden.setoption('kills', 'Kills: %s' % rank[user]['hidden_kills'])
        rank_hidden.setoption('deaths', 'Deaths: %s' % rank[user]['hidden_deaths'])
        rank_hidden.setoption('spawns', 'Spawned as Hidden: %s' % rank[user]['hidden_spawns'])
        rank_hidden.send(userid)
    elif choice == 'iris':
        rank_iris.setoption('kills', 'Kills: %s' % rank[user]['iris_kills'])
        rank_iris.setoption('deaths', 'Deaths: %s' % rank[user]['iris_deaths'])
        rank_iris.send(userid)

def choose_menu(userid, choice, popupid):
    global chosen
    user = playerlib.uniqueid(userid, True)
    if choice == 'assault':
        chosen[user]['class'] = 'assault'
        assault.send(userid)
    elif choice == 'support':
        chosen[user]['class'] = 'support'
        support.send(userid)

def assault_men(userid, choice, popupid):
    global chosen
    user = playerlib.uniqueid(userid, True)
    chosen[user]['prim'] = choice
    sec.send(userid)

def support_men(userid, choice, popupid):
    global chosen
    user = playerlib.uniqueid(userid, True)
    chosen[user]['prim'] = choice
    sec.send(userid)

def sec_men(userid, choice, popupid):
    global chosen
    user = playerlib.uniqueid(userid, True)
    chosen[user]['sec'] = choice
    addition.send(userid)

def addition_men(userid, choice, popupid):
    global chosen
    user = playerlib.uniqueid(userid, True)
    player = playerlib.getPlayer(userid)
    chosen[user]['addition'] = choice
    strip_player(userid)
    gamethread.delayed(.2, es.server.cmd, ('es_xgive %s weapon_%s;es_xgive %s weapon_%s' % (userid, chosen[user]['sec'], userid, chosen[user]['prim'])))
    if chosen[user]['addition'] == 'nvgs':
        gamethread.delayed(0, player.set, ('nightvision', 1))
        gamethread.delayed(1, player.set, ('nightvisionon', 1))
    if chosen[user]['prim'] == 'm4a1':
        player.set('health', 50)
    es.tell(userid, '#multi', '#green[#lightgreenES Hidden#green] #defaultYou\'ll get the new class-specific changes now and after your next respawn.')

def default_rank(user):
    global rank
    rank[user] = {}
    rank[user]['hidden_kills'] = 0
    rank[user]['hidden_deaths'] = 0
    rank[user]['hidden_spawns'] = 0
    rank[user]['roundkills'] = 0
    rank[user]['iris_kills'] = 0
    rank[user]['iris_deaths'] = 0

def default_chosen(user):
    global chosen
    chosen[user] = {}
    chosen[user]['class'] = 0
    chosen[user]['prim'] = 0
    chosen[user]['sec'] = 0
    chosen[user]['addition'] = 0
    chosen[user]['class_time'] = 0
    chosen[user]['adrenaline_reset'] = 0

def player_activate(ev):
    user = playerlib.uniqueid(ev['userid'], True)
    if not user in rank:
        default_rank(user)
    if not user in chosen:
        default_chosen(user)
    save_files()

def player_team(ev):
    userid = ev['userid']
    team = int(ev['team'])
    if hidden_dead == 0:
        if team == 3:
            if es.getplayercount(2) == 0:
                es.tell(ev['userid'], '#multi', '#green[#lightgreenES Hidden#green] #defaultThere must be #lightgreenONE #greenHidden#default!')
                gamethread.delayed(0, es.changeteam, (userid, 2))
        if team == 2:
            if es.getplayercount(2) > 1:
                es.tell(ev['userid'], '#multi', '#green[#lightgreenES Hidden#green] #defaultThere can only be #lightgreenONE #greenHidden#default!')
                gamethread.delayed(0, es.changeteam, (userid, 3))

def player_spawn(ev):
    global rank, chosen
    userid = ev['userid']
    user = playerlib.uniqueid(userid, True)
    player = playerlib.getPlayer(userid)
    es.server.cmd('es_xfire %s hostage_entity kill' % userid)
    gamethread.delayed(0, es.server.cmd, ('es_xfire %s func_buyzone Disable;es_xfire %s func_bomb_target Disable;es_xfire %s func_hostage_rescue Disable' % (userid, userid, userid)))
    if ev['es_userteam'] == '2':
        if es.getplayercount(2) > 1:
            es.tell(ev['userid'], '#multi', '#green[#lightgreenES Hidden#green] #defaultThere can only be #lightgreenONE #greenHidden#default!')
            gamethread.delayed(0, es.changeteam, (userid, 3))
            es.delayed(0, 'mp_restartgame 1')
        elif es.getplayercount(2) < 1:
            es.tell(ev['userid'], '#multi', '#green[#lightgreenES Hidden#green] #defaultThere must be #lightgreenONE #greenHidden#default!')
            gamethread.delayed(0, es.changeteam, (userid, 2))
            es.delayed(0, 'mp_restartgame 1')
        elif es.getplayercount(2) == 1:
            hidden_dead = 0
            rank[user]['hidden_spawns'] += 1
            player.set('health', hidden_health)
            player.set('color', (255, 255, 255, 19))
            strip_player(userid)
            player.set('speed', hidden_speed)
            gamethread.delayed(3, player.set, ('speed', hidden_speed))
            gamethread.delayed(0, es.server.cmd, ('es_xgive %s item_assaultsuit;es_xgive %s weapon_knife' % (userid, userid)))
            es.centertell(ev['userid'], 'You are the Hidden - Rescue yourself!')
            gamethread.delayed(1, es.centertell, (ev['userid'], 'You are the Hidden - Rescue yourself!'))
            gamethread.delayed(2, es.centertell, (ev['userid'], 'You are the Hidden - Rescue yourself!'))
            if rank[user]['roundkills'] == es.getplayercount(3) / 2:
                player.add('health', hidden_health / 2)
                if rank[user]['roundkills'] == 1:
                    es.tell(userid, '#multi', '#green[#lightgreenES Hidden#green] #defaultYou get #green%s #lightgreenHP #defaultfor killing #lightgreen1 #greenIRIS Force#default.' % (int(hidden_health) / 2))
                elif rank[user]['roundkills'] > 1:
                    es.tell(userid, '#multi', '#green[#lightgreenES Hidden#green] #defaultYou get #green%s #lightgreenHP #defaultfor killing #lightgreen%s #greenIRIS Forces#default.' % (int(hidden_health) / 2, rank[user]['roundkills']))
                rank[user]['roundkills'] = 0
            elif rank[user]['roundkills'] == es.getplayercount(3):
                player.add('health', hidden_health)
                if rank[user]['roundkills'] == 1:
                        es.tell(ev['userid'], '#multi', '#green[#lightgreenES Hidden#green] #defaultYou get #green%s #lightgreenHP #defaultfor killing #lightgreen1 #greenIRIS Force#default.' % (hidden_health))
                elif rank[user]['roundkills'] > 1:
                    es.tell(ev['userid'], '#multi', '#green[#lightgreenES Hidden#green] #defaultYou get #green%s #lightgreenHP #defaultfor killing #lightgreen%s #greenIRIS Forces#default.' % (hidden_health, rank[user]['roundkills']))
                rank[user]['roundkills'] = 0
    elif ev['es_userteam'] == '3':
        es.centertell(ev['userid'], '617 has been spotted in this sector - MOVE OUT!')
        gamethread.delayed(1, es.centertell, (ev['userid'], '617 has been spotted in this sector - MOVE OUT!'))
        gamethread.delayed(2, es.centertell, (ev['userid'], '617 has been spotted in this sector - MOVE OUT!'))
        player.set('color', (255, 255, 255, 255))
        strip_player(userid)
        es.tell(ev['userid'], '#multi', '#green[#lightgreenES Hidden#green] #defaultType #lightgreen!class #defaultto change your class.')
        if ev['es_steamid'] == 'BOT':
            prim = random.choice(str(bot_wep_prim).split(';'))
            sec = random.choice(str(bot_wep_sec).split(';'))
            gamethread.delayed(0, es.server.cmd, ('es_xgive %s weapon_%s;es_xgive %s weapon_%s' % (userid, sec, userid, prim)))
        else:
            chosen[user]['class_time'] = 0
            chosen[user]['adrenaline_reset'] = 0
            if chosen[user]['class'] != 0:
                if chosen[user]['class'] == 'assault':
                    player.set('health', 75)
                    if chosen[user]['prim'] == 'm4a1':
                        player.set('health', 50)
                elif chosen[user]['class'] == 'support':
                    player.set('health', 125)
                if chosen[user]['addition'] == 'nvgs':
                    gamethread.delayed(0, player.set, ('nightvision', 1))
                    gamethread.delayed(1, player.set, ('nightvisionon', 1))
                gamethread.delayed(0, es.server.cmd, ('es_xgive %s weapon_%s' % (userid, chosen[user]['sec'])))
                gamethread.delayed(.1, es.server.cmd, ('es_xgive %s weapon_%s' % (userid, chosen[user]['prim'])))
            else:
                default_chosen(user)
                gamethread.delayed(0, choose.send, (userid))

def round_start(ev):
    es.msg('#multi', '#green[#lightgreenES Hidden#green] #lightgreen- #greenMISSION EXECUTE #lightgreen-')
    if dark_mode == 0:
        es.lightstyle(0, 'g')
    elif dark_mode == 1:
        es.lightstyle(0, 'b')
    elif dark_mode == 2:
        es.lightstyle(0, 'a')
    es.cexec_all('play', 'hidden/IRIS-roundstart02.wav')

def strip_player(userid):
    player = playerlib.getPlayer(userid)
    es.server.cmd('es_xfire %s player_weaponstrip kill' % userid)
    es.server.cmd('es_xgive %s player_weaponstrip' % userid)
    es.server.cmd('es_xfire %s player_weaponstrip strip' % userid)
    gamethread.delayed(0, es.server.cmd, ('es_xgive %s item_assaultsuit;es_xgive %s weapon_knife' % (userid, userid)))

def item_pickup(ev):
    userid = ev['userid']
    if ev['es_userteam'] == '2' and ev['item'] != 'knife':
        es.server.cmd('es_xfire %s player_weaponstrip kill' % userid)
        es.server.cmd('es_xgive %s player_weaponstrip' % userid)
        es.server.cmd('es_xfire %s player_weaponstrip strip' % userid)
        gamethread.delayed(0, es.server.cmd, ('es_xgive %s weapon_knife' % userid))

def player_death(ev):
    global rank, hidden_dead
    player = playerlib.getPlayer(ev['attacker'])
    victim = playerlib.uniqueid(ev['userid'], True)
    attacker = playerlib.uniqueid(ev['attacker'], True)
    attacker_uid = ev['attacker']
    userid = ev['userid']
    if ev['es_userteam'] == '2' and ev['es_attackerteam'] == '3':
        hidden_dead = 1
        rank[victim]['hidden_deaths'] += 1
        rank[attacker]['iris_kills'] += 1
        hidden_death = random.choice(death_hidden)
        es.cexec(ev['userid'], 'playgamesound', hidden_death)
        es.msg('#multi', '#green[#lightgreenES Hidden#green] %s #lightgreenis now the #greenHidden #lightgreen:D' % es.getplayername(attacker_uid))
        gamethread.delayed(0, es.changeteam, (attacker_uid, 2))
        gamethread.delayed(1, es.changeteam, (userid, 3))
        es.delayed(3, 'mp_restartgame 1')
    if ev['es_userteam'] == '3' and ev['es_attackerteam'] == '2':
        rank[victim]['iris_deaths'] += 1
        rank[attacker]['hidden_kills'] += 1
        rank[attacker]['roundkills'] += 1
        player.set('speed', hidden_speed + 0.3)
        player.add('health', int(hidden_health) / int(additional_hidden_health))
        sound = random.choice(sounds)
        es.cexec_all('play', sound)
        iris_death = random.choice(death_iris)
        es.cexec(ev['userid'], 'playgamesound', iris_death)
        es.msg('#multi', '#green[#lightgreenES Hidden#green] Hidden #lightgreen%s #defaultgot #green%s #lightgreenHP #defaultfor killing #green%s' % (es.getplayername(attacker_uid), hidden_health / int(additional_hidden_health), es.getplayername(userid)))

def player_disconnect(ev):
    save_files()

def save_files():
    rank_file = open(es.getAddonPath('hidden') + '/rank.db', 'w')
    chosen_file = open(es.getAddonPath('hidden') + '/chosen.db', 'w')
    pickle.dump(rank, rank_file)
    pickle.dump(chosen, chosen_file)
    rank_file.close()
    chosen_file.close()
